﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Threading;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace hamilton
{
    public partial class Form1 : Form
    {
        internal string permt = "";
        private ControlInvoker controlInvoker;
        private System.Threading.Thread myThread = null;
        internal bool merget = false;
        public Form1()
        {
            InitializeComponent();
            controlInvoker = new ControlInvoker(this);
        }

        public bool verificarelista()
        {
            double x = 0;
            for (int i = 0; i < this.listView1.Items.Count;i++)
            {
                for (int j = 0; j < this.listView1.Columns.Count; j++)
                {
                    try
                    {
                        x = double.Parse(this.listView1.Items[i].SubItems[j].Text);
                    }
                    catch
                    {
                        MessageBox.Show("In lista, la linia "+(i+1).ToString()+ " si coloana "+(j+1).ToString()+" se afla `"+ this.listView1.Items[i].SubItems[j].Text + "` care nu e numar!");
                        return false;
                    }
                }
            }
            return true;
        }
        private void listView1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.V && e.Modifiers == Keys.Control)
            {
                this.listView1.Items.Clear();
                this.listView1.Columns.Clear();
                string copa = Clipboard.GetText();
                string[] ll = copa.Split(new char[] { '\n' });
                string[] detl = null;
                int nrcol = 0;
                for (int i = 0; i < ll.Length; i++)
                {
                    nrcol = Math.Max(nrcol, ll[i].Replace("\r", "").Split(new char[] { '\t' }).Length);
                }
                string[] linie = new string[nrcol];
                for (int i = 0; i < nrcol; i++)
                {
                    this.listView1.Columns.Add("", 60);
                }
                for (int i = 0; i < ll.Length; i++)
                {
                    if (ll[i].Length > 0)
                    {
                        detl = ll[i].Replace("\r", "").Split(new char[] { '\t' });
                        for (int j = 0; j < detl.Length; j++)
                        {
                            linie[j] = detl[j];
                        }
                        for (int j = detl.Length; j < nrcol; j++)
                        {
                            linie[j] = "";
                        }
                        this.listView1.Items.Add(new ListViewItem(linie));
                    }
                }
            }
        }

        public void Permutations(string input, System.Text.StringBuilder sb)
        {
            if (sb.Length == input.Length)
            {
                this.permt += "\n" + sb.ToString();
                return;
            }

            char[] inChar = input.ToCharArray();

            for (int i = 0; i < input.Length; i++)
            {
                if (!sb.ToString().Contains(inChar[i].ToString()))
                {
                    sb.Append(inChar[i]);
                    Permutations(input, sb);
                    RemoveChar(sb, inChar[i]);
                }
            }
        }

        public bool RemoveChar(System.Text.StringBuilder input, char toRemove)
        {
            int index = input.ToString().IndexOf(toRemove);
            if (index >= 0)
            {
                input.Remove(index, 1);
                return true;
            }
            return false;
        }
        
        private void xpButton3_Click(object sender, EventArgs e)
        {
            MessageBox.Show("1.`Permutari` genereaza permutarile coloanelor si le pune in textbox-ul din stanga jos.\r\n\r\n2.`Hamilton` gaseste circuitul hamiltonian de lungime minima, luand la rand toate circuitele posibile.\r\nSe construieste matricea patratica a grafului (toate componentele numere) intr-un excel, se ia cu Copy(Ctrl+C), apoi se da Paste(Ctrl+V) in program, dupa ce s-a dat click in lista.\r\nObservatie: De la dimensiunea 10 in sus rezolvarea dureaza foarte mult.\r\n\r\n3. `Ordonantare` gaseste ordinea de durata minima la ordonantarea in flux, pe linii fiind utilajele si pe coloane reperele. Obs: datele se aduc ca si la Hamilton.\r\n\r\n4. `Determinant` gaseste determinantul matricii patratice aflate in lista.\r\n\r\n5. `Regresie` gaseste coeficientii regresiei simple sau multiple corespunzatoare listei, prin metoda celor mai mici patrate. In lista ultima coloana corespunde valorilor variabilei dependente (Y) iar celelalte variabilelor independente de care depinde Y (Xi).\r\n\r\n6. Durbin-Watson: Gaseste indicele Durbin-Watson de corelatie.\r\n\r\n7. Arbore: Gaseste arborele de valoare minima prin algoritmul lui Kruskal pe un graf neorientat\r\n\r\n8. Dijkstra: gaseste drumul minim de la nodul corespunzator primei coloane la nodul corespunzator ultimei prin algoritmul lui Dijkstra.\r\n\r\n9. Flux: gaseste fluxul de valoare maxima de la surse(liniile) la destinatii (coloanele). Prima coloana si prima linie contin disponibilurile respectiv cererile.");
        }

        private void UpdateUI(object[] arguments)
        {
            //usage: controlInvoker.Invoke (new MethodCallInvoker (UpdateUI), "1", "some text");
            string[] ddtt = null;
            switch ((string)arguments[0])
            {
                case "0":
                    this.total.Text = (string)arguments[1];
                    break;
                case "1":
                    this.curenta.Text = (string)arguments[1];
                    break;
                default:
                    break;
            }
        }

        public void ordonantare()
        {
            this.merget = true;
            this.permt = "";
            double[] finaluri = new double[this.listView1.Items.Count];
            if (this.listView1.Columns.Count < 10)
            {
                string nr = "";
                for (int i = 0; i < this.listView1.Columns.Count; i++)
                {
                    nr += i.ToString();
                }
                this.Permutations(nr, new System.Text.StringBuilder());
                string[] prr = this.permt.Trim(new char[] { '\n' }).Split(new char[] { '\n' });
                double minlen = 1000000;
                string tras = "";
                controlInvoker.Invoke(new MethodCallInvoker(UpdateUI), "0", prr.Length.ToString());
                for (int i = 0; i < prr.Length; i++)
                {
                    controlInvoker.Invoke(new MethodCallInvoker(UpdateUI), "1", (i + 1).ToString());
                    for (int i0 = 0; i0 < finaluri.Length; i0++)
                    {
                        finaluri[i0] = 0;
                    }
                    for (int j = 0; j < this.listView1.Columns.Count; j++)
                    {
                        try
                        {
                            finaluri[0] += double.Parse(this.listView1.Items[0].SubItems[int.Parse(prr[i].Substring(j, 1))].Text);
                        }
                        catch { MessageBox.Show("la celula:0;" + j.ToString() + " valoare `" + this.listView1.Items[0].SubItems[int.Parse(prr[i].Substring(j, 1))].Text + "` nu e numar!"); }
                        for (int k = 1; k < this.listView1.Items.Count; k++)
                        {
                            try
                            {
                                finaluri[k] = Math.Max(finaluri[k - 1], finaluri[k]) + double.Parse(this.listView1.Items[k].SubItems[int.Parse(prr[i].Substring(j, 1))].Text);
                            }
                            catch { MessageBox.Show("la celula:" + k.ToString() + ";" + j.ToString() + " valoare `" + this.listView1.Items[k].SubItems[int.Parse(prr[i].Substring(j, 1))].Text + "` nu e numar!"); }
                        }
                    }

                    if (finaluri[this.listView1.Items.Count - 1] < minlen)
                    {
                        minlen = finaluri[this.listView1.Items.Count - 1];
                        tras = prr[i];
                    }
                }
                MessageBox.Show("min=" + minlen.ToString() + "\r\ntras=" + tras);
            }
            else
            {
                MessageBox.Show("Trebuie sa fie maxim 9 coloane (repere)");
            }
            this.merget = false;
        }
        private void xpButton4_Click(object sender, EventArgs e)
        {//ordonantare
            if (!this.verificarelista())
                return;
            if (this.merget)
                return;
            this.myThread = new System.Threading.Thread(new System.Threading.ThreadStart(this.ordonantare));
            this.merget = true;
            this.myThread.Start();
        }

        private void xpButton1_Click(object sender, EventArgs e)
        {
            this.permt = "";
            if (this.listView1.Columns.Count < 10)
            {
                string nr = "";
                for (int i = 0; i < this.listView1.Columns.Count; i++)
                {
                    nr += i.ToString();
                }
                this.Permutations(nr, new System.Text.StringBuilder());
                this.richTextBox1.Text = this.permt.Trim(new char[] { '\n' });
            }
        }
        public void hamil()
        {
            this.merget = true;
            this.permt = "";
            if (this.listView1.Columns.Count < 10)
            {
                string nr = "";
                for (int i = 0; i < this.listView1.Columns.Count; i++)
                {
                    nr += i.ToString();
                }
                this.Permutations(nr, new System.Text.StringBuilder());
                string[] prr = this.permt.Trim(new char[] { '\n' }).Split(new char[] { '\n' });
                double minlen = 1000000;
                string tras = "";
                double lenc = 0;
                controlInvoker.Invoke(new MethodCallInvoker(UpdateUI), "0", prr.Length.ToString());
                for (int i = 0; i < prr.Length; i++)
                {
                    controlInvoker.Invoke(new MethodCallInvoker(UpdateUI), "1", (i + 1).ToString());
                    lenc = 0;
                    for (int j = 1; j < this.listView1.Columns.Count; j++)
                    {
                        lenc += double.Parse(this.listView1.Items[int.Parse(prr[i].Substring(j - 1, 1))].SubItems[int.Parse(prr[i].Substring(j, 1))].Text);
                    }
                    lenc += double.Parse(this.listView1.Items[int.Parse(prr[i].Substring(this.listView1.Columns.Count - 1, 1))].SubItems[int.Parse(prr[i].Substring(0, 1))].Text);
                    if (lenc < minlen)
                    {
                        minlen = lenc;
                        tras = prr[i] + prr[i].Substring(0, 1);
                        //MessageBox.Show("min=" + minlen.ToString() + "\r\ntras=" + tras);
                    }
                }
                MessageBox.Show("min=" + minlen.ToString() + "\r\ntras=" + tras);
            }
            else
            {
                MessageBox.Show("Trebuie sa fie maxim 9 coloane (noduri in graf)");
            }
            this.merget = false;
        }
        private void xpButton2_Click(object sender, EventArgs e)
        {
            if (!this.verificarelista())
                return;
            if (this.merget)
                return;
            this.myThread = new System.Threading.Thread(new System.Threading.ThreadStart(this.hamil));
            this.merget = true;
            this.myThread.Start();
            
        }
        public int rangperm(int[] permu)
        {
            int rang = 0;
            for(int i=0;i<permu.Length;i++)
            {
                for (int j = i+1; j < permu.Length; j++)
                {
                    if (permu[i] > permu[j])
                        rang++;
                }
            }
            return rang;
        }
        public double det(double[,] matrix)
        {
            double detu = 1;
            bool nuare = true;
            int size = matrix.GetLength(0);
            int[] permutare=new int[size];
            double aij = 0;
            double bij = 0;
            for (int i = 0; i < matrix.GetLength(0); i++)
            {
                nuare = true;
                for (int j = 0; j < matrix.GetLength(1); j++)
                {
                    if (matrix[i, j] != 0)
                    {
                        aij= matrix[i, j];
                        nuare = false;
                        for (int j1 = 0; j1 < matrix.GetLength(1); j1++)
                        {
                            if (j1 != j)
                            {
                                bij= matrix[i, j1];
                                for (int i1 = i; i1 < matrix.GetLength(0); i1++)
                                {
                                    matrix[i1, j1] = matrix[i1, j1] - matrix[i1, j] * bij / aij;
                                    //this.listView1.Items[i1].SubItems[j1].Text = matrix[i1, j1].ToString();
                                }
                            }
                        }
                        for (int i1 = i + 1; i1 < matrix.GetLength(1); i1++)
                        {
                            matrix[i1, j] = 0;
                        }
                        detu = detu * aij;
                        permutare[i] = j;
                        break;
                    }
                }
                if (nuare)
                    return 0;
            }
            return detu*Math.Pow(-1,this.rangperm(permutare));
        }

        private void xpButton5_Click(object sender, EventArgs e)
        {
            if(this.listView1.Items.Count!=this.listView1.Columns.Count)
            {
                MessageBox.Show("In lista trebuie sa fie o matrice patratica. Acum sunt "+ this.listView1.Items.Count.ToString()+ " linii si "+ this.listView1.Columns.Count.ToString() + " coloane");
            }
            if (!this.verificarelista())
                return;
            double[,] matrix = new double[this.listView1.Items.Count, this.listView1.Columns.Count];
            for(int i=0;i<this.listView1.Items.Count;i++)
            {
                for (int j = 0; j < this.listView1.Columns.Count;j++)
                {
                    matrix[i, j] = double.Parse(this.listView1.Items[i].SubItems[j].Text);
                }
            }
            MessageBox.Show(this.det(matrix).ToString());
        }
        public double[] regres()
        {
            if (this.listView1.Columns.Count < 2)
            {
                MessageBox.Show("Trebuie sa fie cel putin 2 coloane!");
                return null;
            }
            if (this.listView1.Items.Count < 2)
            {
                MessageBox.Show("Trebuie sa fie cel putin 2 linii!");
                return null;
            }
            if (this.listView1.Items.Count < 30 + 10 * (this.listView1.Columns.Count - 2))
            {
                MessageBox.Show("Regression with only one dependent and one independent variable normally requires a minimum of 30 observations.\r\nA good rule of thumb is to add at least an additional 10 observations for each additional independent variable added to the equation.");
            }
            if (!this.verificarelista())
                return null;
            int dimensiune = this.listView1.Columns.Count;
            double[,] matrice = new double[dimensiune, dimensiune];
            double[,] matrice2 = new double[dimensiune, dimensiune];
            double[] termlib = new double[dimensiune];
            double[] coef = new double[dimensiune];
            for (int i = 0; i < dimensiune; i++)
            {
                if (i == 0)
                {
                    termlib[0] = 0;
                    for (int j = 0; j < this.listView1.Items.Count; j++)
                    {
                        termlib[0] += double.Parse(this.listView1.Items[j].SubItems[dimensiune - 1].Text);
                    }
                }
                else
                {
                    termlib[i] = 0;
                    for (int j = 0; j < this.listView1.Items.Count; j++)
                    {
                        termlib[i] += double.Parse(this.listView1.Items[j].SubItems[i - 1].Text) * double.Parse(this.listView1.Items[j].SubItems[dimensiune - 1].Text);
                    }
                }
                for (int j = 0; j < dimensiune; j++)
                {
                    matrice[i, j] = 0;
                    if (i == 0)
                    {
                        if (j == 0)
                        {
                            matrice[0, 0] = (double)this.listView1.Items.Count;
                        }
                        else
                        {
                            for (int j1 = 0; j1 < this.listView1.Items.Count; j1++)
                            {
                                matrice[0, j] += double.Parse(this.listView1.Items[j1].SubItems[j - 1].Text);
                            }
                        }
                    }
                    else
                    {
                        if (j == 0)
                        {
                            for (int j1 = 0; j1 < this.listView1.Items.Count; j1++)
                            {
                                matrice[i, 0] += double.Parse(this.listView1.Items[j1].SubItems[i - 1].Text);
                            }
                        }
                        else
                        {
                            for (int j1 = 0; j1 < this.listView1.Items.Count; j1++)
                            {
                                matrice[i, j] += double.Parse(this.listView1.Items[j1].SubItems[i - 1].Text) * double.Parse(this.listView1.Items[j1].SubItems[j - 1].Text);
                            }
                        }
                    }
                    //MessageBox.Show("matrice[" + i.ToString() + "," + j.ToString() + "]=" + matrice[i, j].ToString());
                }
            }
            for (int i1 = 0; i1 < dimensiune; i1++)
            {
                for (int j1 = 0; j1 < dimensiune; j1++)
                {
                    matrice2[i1, j1] = matrice[i1, j1];
                }
            }
            double detjos = this.det(matrice);
            for (int i1 = 0; i1 < dimensiune; i1++)
            {
                for (int j1 = 0; j1 < dimensiune; j1++)
                {
                    matrice[i1, j1] = matrice2[i1, j1];
                }
            }
            if (detjos == 0)
            {
                MessageBox.Show("Variabilele nu sunt independente!");
                return null;
            }
            for (int i = 0; i < dimensiune; i++)
            {
                for (int i1 = 0; i1 < dimensiune; i1++)
                {
                    for (int j1 = 0; j1 < dimensiune; j1++)
                    {
                        //MessageBox.Show("matrice[" + i1.ToString()+","+j1.ToString() + "]=" + matrice[i1,j1].ToString());
                        if (j1 == i)
                        {
                            matrice2[i1, j1] = termlib[i1];
                        }
                        else
                        {
                            matrice2[i1, j1] = matrice[i1, j1];
                        }
                    }
                }
                coef[i] = this.det(matrice2) / detjos;
            }
            return coef;
        }
        private void xpButton6_Click(object sender, EventArgs e)
        {
            double[] coco = this.regres();
            string mesaj = "";
            if (coco != null)
            {
                mesaj = "b0=" + coco[0].ToString();
                for (int i=1;i<coco.Length;i++)
                    mesaj += "\r\nb" + i.ToString() + "=" + coco[i].ToString();
            }
            MessageBox.Show(mesaj);
        }

        private void xpButton7_Click(object sender, EventArgs e)
        {
            double[] coco = this.regres();
            double[] calculate = new double[this.listView1.Items.Count];
            double[] erori = new double[this.listView1.Items.Count];
            double[] dife = new double[this.listView1.Items.Count-1];
            double sumper = 0;
            double sumpdif = 0;
            for (int i=0;i<this.listView1.Items.Count;i++)
            {
                calculate[i] = coco[0];
                for(int j=0;j<this.listView1.Columns.Count-1;j++)
                {
                    calculate[i] += coco[j+1] * double.Parse(this.listView1.Items[i].SubItems[j].Text);
                }
                erori[i]= double.Parse(this.listView1.Items[i].SubItems[this.listView1.Columns.Count-1].Text) - calculate[i];
                sumper += erori[i] * erori[i];
                if (i>0)
                {
                    dife[i - 1] = erori[i] - erori[i - 1];
                    sumpdif += dife[i - 1] * dife[i - 1];
                }
            }
            MessageBox.Show("Durbin-Watson = "+(sumpdif / sumper).ToString());
        }
        internal int ainaintedeb(double[] a, double[] b)
        {//a<b => -1. a=b => 0, a>b => 1
            int rez = 0;
            for(int i=0;i<a.Length;i++)
            {
                if (a[i] < b[i])
                {
                    rez=-1;
                    break;
                }
                else if (a[i] > b[i])
                {
                    rez = 1;
                    break;
                }
            }
            return rez;
        }
        private void xpButton8_Click(object sender, EventArgs e)
        {
            if (this.listView1.Items.Count != this.listView1.Columns.Count)
            {
                MessageBox.Show("In lista trebuie sa fie o matrice patratica. Acum sunt " + this.listView1.Items.Count.ToString() + " linii si " + this.listView1.Columns.Count.ToString() + " coloane");
            }
            double x = 0;
            for (int i = 0; i < this.listView1.Items.Count; i++)
            {
                for (int j = i+1; j < this.listView1.Columns.Count; j++)
                {
                    if (this.listView1.Items[i].SubItems[j].Text.Length > 0)
                    {
                        try
                        {
                            x = double.Parse(this.listView1.Items[i].SubItems[j].Text);
                            if(x<0)
                            {
                                MessageBox.Show("In lista, la linia " + (i + 1).ToString() + " si coloana " + (j + 1).ToString() + " se afla `" + this.listView1.Items[i].SubItems[j].Text + "` care e numar negativ!");
                                return;
                            }
                            if (x == 0)
                                this.listView1.Items[i].SubItems[j].Text = "";
                        }
                        catch
                        {
                            MessageBox.Show("In lista, la linia " + (i + 1).ToString() + " si coloana " + (j + 1).ToString() + " se afla `" + this.listView1.Items[i].SubItems[j].Text + "` care nu e numar!");
                            return;
                        }
                    }
                    if(this.listView1.Items[i].SubItems[j].Text!="" && this.listView1.Items[j].SubItems[i].Text!="" && this.listView1.Items[i].SubItems[j].Text != this.listView1.Items[j].SubItems[i].Text)
                    {
                        MessageBox.Show("Pozitia ("+(i+1).ToString()+ ","+(j+1).ToString()+") are valoarea `"+ this.listView1.Items[i].SubItems[j].Text + "` care e diferita de pozitia ("+(j+1).ToString()+ ","+(i+1).ToString()+ ") care are valoarea `"+ this.listView1.Items[i].SubItems[j].Text + "` => matricea nu e simetrica => graful asociat nu e neorientat.");
                    }
                    this.listView1.Items[j].SubItems[i].Text = "";
                }
                this.listView1.Items[i].SubItems[i].Text = "";
            }
            //1. Sortare arce dupa valoare, apoi dupa indici
            string arce = "";
            for (int i = 0; i < this.listView1.Items.Count; i++)
            {
                for (int j = i+1; j < this.listView1.Columns.Count; j++)
                {
                    if (this.listView1.Items[i].SubItems[j].Text.Length > 0)
                    {
                        arce += (arce.Length > 0 ? "\n" : "") + (i+1).ToString() + "\t" + (j+1).ToString() + "\t" + this.listView1.Items[i].SubItems[j].Text;
                    }
                }
            }
            if(arce.Length>0)
            {
                string[] varce = arce.Split(new char[] {'\n'});
                if(varce.Length<this.listView1.Items.Count)
                {
                    MessageBox.Show("Graful trebuie sa aiba macar "+ this.listView1.Items.Count.ToString() + " arce, altfel nu e nici macar convex!");
                    return;
                }
                string[] detarc = null;
                double[,] arcs = new double[arce.Length, 3];
                for(int i=0;i<varce.Length;i++)
                {
                    detarc = varce[i].Split(new char[] {'\t'});
                    arcs[i, 0] = double.Parse(detarc[0]);
                    arcs[i, 1] = double.Parse(detarc[1]);
                    arcs[i, 2] = double.Parse(detarc[2]);
                }
                double temp = 0;
                for (int i = 0; i < varce.Length-1; i++)
                {
                    for (int j = i+1; j < varce.Length; j++)
                    {
                        if(this.ainaintedeb(new double[3] { arcs[i, 2], arcs[i,0], arcs[i, 1]}, new double[3] { arcs[j, 2], arcs[j, 0], arcs[j, 1] }) >0)
                        {
                            for(int k=0;k<3;k++)
                            {
                                temp = arcs[i, k];
                                arcs[i, k] = arcs[j, k];
                                arcs[j, k] = temp;
                            }
                        }
                    }
                }
                //2. Initializare cutii noduri
                string[] cutii = new string[this.listView1.Items.Count];
                for(int i=0;i<cutii.Length;i++)
                {
                    cutii[i] = "~" + (i + 1).ToString() + "~";
                }
                int arcealese = 0;
                int poz = 0;
                string arbore = "";
                int cut1 = -1;
                int cut2 = -1;
                //2. In ordinea crescatoare se aleg arcele
                while (arcealese < cutii.Length - 1 && poz<varce.Length)
                {
                    cut1 = -1;
                    cut2 = -1;
                    for (int i = 0; i < cutii.Length; i++)
                    {
                        if (cut1==-1&&cutii[i].IndexOf("~" + arcs[poz,0].ToString() +"~")>=0)
                        {
                            cut1 = i;
                        }
                        if(cut2==-1&&cutii[i].IndexOf("~" + arcs[poz, 1].ToString() + "~") >= 0)
                        {
                            cut2 = i;
                        }
                        if (cut1 >= 0 && cut2 >= 0)
                            break;
                    }
                    if(cut1!=cut2)
                    {
                        arbore += (arbore.Length > 0 ? "\n" : "") + arcs[poz, 0] + "\t" + arcs[poz, 1] + "\t" + arcs[poz, 2];
                        arcealese++;
                        cutii[cut1] += cutii[cut2].Substring(1);
                        cutii[cut2] = "";
                    }
                    poz++;
                }
                if(arcealese == cutii.Length - 1)
                {
                    this.richTextBox1.Text = arbore;
                }
                else
                {
                    this.richTextBox1.Text = arbore;
                    MessageBox.Show("Graful nu e conex.");
                }
            }
            else
            {
                MessageBox.Show("Graful nu contine nici un arc!");
            }
        }

        private void xpButton9_Click(object sender, EventArgs e)
        {
            if (this.listView1.Items.Count != this.listView1.Columns.Count)
            {
                MessageBox.Show("In lista trebuie sa fie o matrice patratica. Acum sunt " + this.listView1.Items.Count.ToString() + " linii si " + this.listView1.Columns.Count.ToString() + " coloane");
            }
            double x = 0;
            for (int i = 0; i < this.listView1.Items.Count; i++)
            {
                for (int j = i + 1; j < this.listView1.Columns.Count; j++)
                {
                    if (this.listView1.Items[i].SubItems[j].Text.Length > 0)
                    {
                        try
                        {
                            x = double.Parse(this.listView1.Items[i].SubItems[j].Text);
                            if (x < 0)
                            {
                                MessageBox.Show("In lista, la linia " + (i + 1).ToString() + " si coloana " + (j + 1).ToString() + " se afla `" + this.listView1.Items[i].SubItems[j].Text + "` care e numar negativ!");
                                return;
                            }
                        }
                        catch
                        {
                            MessageBox.Show("In lista, la linia " + (i + 1).ToString() + " si coloana " + (j + 1).ToString() + " se afla `" + this.listView1.Items[i].SubItems[j].Text + "` care nu e numar!");
                            return;
                        }
                    }
                }
            }
            int N = this.listView1.Items.Count;
            double[,] matrice = new double[N, N];
            for (int i = 0; i < N; i++)
            {
                for (int j = 0; j < N; j++)
                {
                    if (this.listView1.Items[i].SubItems[j].Text.Length > 0)
                    {
                        matrice[i, j] = double.Parse(this.listView1.Items[i].SubItems[j].Text);
                    }
                    else
                    {
                        matrice[i, j] = -1;//-1 unde nu exista arc
                    }
                }
            }
            double[] valnod = new double[N];//-1 = neatins
            int[] deftemp = new int[N];//-1=neatins,0=temporar,1=definitiv
            string[] nodant = new string[N];
            valnod[0] = 0;
            deftemp[0] = 1;
            for(int i=1;i< N;i++)
            {
                valnod[i] = -1;
                deftemp[i] = -1;
            }
            double valcalc = 10000000000;
            double tempmin  = 10000000000;
            while (deftemp[N-1]<=0)
            {
                //1. intra in temporare noduri neatinse in care ajung din definitive
                for (int i=0;i<N;i++)
                {
                    if (deftemp[i]==1)
                    {
                        for (int j=0;j< N;j++)
                        {
                            if (j != i)
                            {
                                if (matrice[i, j] >= 0 && deftemp[j] == -1)
                                {
                                    deftemp[j] = 0;
                                }
                            }
                        }
                    }
                }
                //2. Pentru fiecare temporar calculez valoarea
                for (int i = 0; i < N; i++)
                {
                    if (deftemp[i] == 0)
                    {
                        valcalc = 10000000000;
                        nodant[i] = "";
                        for (int j = 0; j < N; j++)
                        {
                            if (j!=i && deftemp[j] >= 0 && valnod[j]>=0 && matrice[i, j] >= 0)
                            {
                                if (valnod[j] + matrice[i, j] < valcalc)
                                {
                                    valcalc = valnod[j] + matrice[i, j];
                                    nodant[i] = j.ToString();
                                }
                                else if(valcalc == valnod[j] + matrice[i, j])
                                {
                                    nodant[i] += ","+j.ToString();
                                }
                            }
                        }
                        valnod[i] = valcalc;
                    }
                }
                tempmin = 10000000000;
                for (int i = 0; i < N; i++)
                {
                    if (deftemp[i] == 0)
                    {
                        tempmin = Math.Min(tempmin, valnod[i]);
                    }
                }
                for (int i = 0; i < N; i++)
                {
                    if (deftemp[i] == 0 && valnod[i] == tempmin)
                    {
                        deftemp[i] = 1;
                    }
                }
            }
            int nodul = N - 1;
            string drum = nodul.ToString();
            while (nodul != 0)
            {
                nodul = int.Parse(nodant[nodul]);
                drum = nodul.ToString() + "->" + drum;
            }
            MessageBox.Show(drum + "\r\n" + "L="+valnod[N-1].ToString());
        }

        private void xpButton10_Click(object sender, EventArgs e)
        {
            this.richTextBox1.Text = "Flux maxim. Ford Fulkerson";
            double x = 0;
            for (int i = 0; i < this.listView1.Items.Count; i++)
            {
                for (int j = 0; j < this.listView1.Columns.Count; j++)
                {
                    if (this.listView1.Items[i].SubItems[j].Text.Length > 0)
                    {
                        try
                        {
                            x = double.Parse(this.listView1.Items[i].SubItems[j].Text);
                            if (x < 0)
                            {
                                MessageBox.Show("In lista, la linia " + (i + 1).ToString() + " si coloana " + (j + 1).ToString() + " se afla `" + this.listView1.Items[i].SubItems[j].Text + "` care e numar negativ!");
                                return;
                            }
                        }
                        catch
                        {
                            MessageBox.Show("In lista, la linia " + (i + 1).ToString() + " si coloana " + (j + 1).ToString() + " se afla `" + this.listView1.Items[i].SubItems[j].Text + "` care nu e numar!");
                            return;
                        }
                    }
                }
            }
            int N = this.listView1.Items.Count + this.listView1.Columns.Count;
            double[,] capacitati = new double[N, N];
            double[,] flux = new double[N, N];
            string[] marcaje = new string[N];
            double crescf = 0;
            for (int i=0;i<N;i++)
            {
                for (int j = 0; j < N; j++)
                {
                    capacitati[i, j] = -1;
                    flux[i, j] = -1;
                }
            }
            for (int i = 1; i < this.listView1.Items.Count; i++)
            {
                capacitati[0, i] = double.Parse(this.listView1.Items[i].SubItems[0].Text);
                flux[0,i]= 0;
            }
            for (int j = 1; j < this.listView1.Columns.Count; j++)
            {
                capacitati[this.listView1.Items.Count+j-1, N-1] = double.Parse(this.listView1.Items[0].SubItems[j].Text);
                flux[this.listView1.Items.Count + j - 1, N-1] = 0;
            }
            for (int i = 1; i < this.listView1.Items.Count; i++)
            {
                for (int j = 1; j < this.listView1.Columns.Count; j++)
                {
                    capacitati[i, this.listView1.Items.Count + j - 1] = double.Parse(this.listView1.Items[i].SubItems[j].Text);
                    flux[i, this.listView1.Items.Count + j - 1] = 0;
                }
            }
            bool tmarcat = true;
            int oldnr = 0;
            int newnr = 1;
            string nodant = "";
            int nodcur = -1;
            double fluxtot = 0;
            string drum = "";
            string sd = "";
            while(tmarcat)
            {
                marcaje[0] = "+";
                for (int i = 1; i < N; i++)
                {
                    marcaje[i] = "";
                }
                oldnr = 0;
                newnr = 1;
                while (newnr>oldnr)
                {
                    oldnr = newnr;
                    for(int i=0;i<N;i++)
                    {
                        if (marcaje[i]!="")
                        {
                            for (int j = 0; j < N; j++)
                            {
                                if (j!=i)
                                {
                                    if (marcaje[j]==""&& capacitati[i, j] > 0 && flux[i, j] >=0 && capacitati[i, j] > flux[i, j])
                                    {
                                        marcaje[j] = "+" + i.ToString();
                                        newnr++;
                                    }
                                    if (marcaje[j] == "" && flux[j, i] > 0)
                                    {
                                        marcaje[j] = "-" + i.ToString();
                                        newnr++;
                                    }
                                }
                            }
                        }
                    }
                }
                if (marcaje[N-1]!="")
                {
                    crescf = 1000000000;
                    nodcur = N - 1;
                    nodant = marcaje[nodcur];
                    while(nodant!="+")
                    {
                        if(nodant.Substring(0,1)=="+")
                        {
                            //MessageBox.Show(nodant+"->"+nodcur+"="+(capacitati[int.Parse(nodant.Substring(1)), nodcur] - flux[int.Parse(nodant.Substring(1)), nodcur]).ToString());
                            crescf = Math.Min(crescf, capacitati[int.Parse(nodant.Substring(1)), nodcur] - flux[int.Parse(nodant.Substring(1)), nodcur]);
                        }
                        else
                        {
                            //MessageBox.Show(nodant + "<-" + nodcur + "=" + flux[nodcur, int.Parse(nodant.Substring(1))].ToString());
                            crescf = Math.Min(crescf, flux[nodcur,int.Parse(nodant.Substring(1))]);
                        }
                        nodcur = int.Parse(nodant.Substring(1));
                        nodant = marcaje[nodcur];
                    }
                    drum = "T";
                    nodcur = N - 1;
                    nodant = marcaje[nodcur];
                    while (nodant != "+")
                    {
                        sd = "";
                        if(int.Parse(nodant.Substring(1))==0)
                        {
                            sd = "S";
                        }
                        else if (int.Parse(nodant.Substring(1)) == N-1)
                        {
                            sd = "T";
                        }
                        else if (int.Parse(nodant.Substring(1)) < this.listView1.Items.Count)
                        {
                            sd = "L"+ nodant.Substring(1);
                        }
                        else if (int.Parse(nodant.Substring(1)) < N-1)
                        {
                            sd = "C" + (int.Parse(nodant.Substring(1)) - this.listView1.Items.Count + 1).ToString();
                        }
                        if (nodant.Substring(0, 1) == "+")
                        {
                            flux[int.Parse(nodant.Substring(1)), nodcur]+=crescf;
                            drum = sd + "->" + drum;
                        }
                        else
                        {
                            flux[nodcur,int.Parse(nodant.Substring(1))]-=crescf;
                            drum = sd + "<-" + drum;
                        }
                        nodcur = int.Parse(nodant.Substring(1));
                        nodant = marcaje[nodcur];
                    }
                    this.richTextBox1.AppendText("\r\n" + drum + ": " + crescf.ToString());
                    fluxtot += crescf;
                }
                else
                {
                    tmarcat = false;
                }
            }
            this.richTextBox1.AppendText("\r\nFlux maxim: " + fluxtot.ToString());
        }
    }
}
